%% calc_min_dist_from_IDD_plane: Calculate the closest distance between the DNA and the IDD plane
% 
% Arguments:
% 	DNA_coord: Coordinates of the DNA. Type: 3xN double
% 	plane_normal: Vector of the IDD plane normal. Type: 3x1 double
% 	mean_mid_point_transitions: Mean of the mid-point of the transition points. Type: 3x1 double
function [min_dist] = calc_min_dist_from_IDD_plane(DNA_coord, plane_normal, mean_mid_point_transitions)
	min_dist = 1e100;

	for atom_idx = 1:size(DNA_coord,2)
		current_dist_from_plane = abs(dot((DNA_coord(:,atom_idx) - mean_mid_point_transitions), plane_normal));

		if current_dist_from_plane < min_dist
			min_dist = current_dist_from_plane;
		end
	end
end

