%% trans_rot: Translate x, y, z and rotate coordinates using Z-Y-Z Euler angles
% 
% Arguments: 
% 	coord: Coordinates to be translated and rotated. Type: 3xN double
% 	z_twist, theta, phi: Rotation angles for Z-Y-Z respectively. Type: double
% 	trans_vec: Translation vector. Type: 3x1 double
% 
% Returns:
% 	coord: Translated and rotated coordinates. Type 3xN double
function [coord] = trans_rot(coord, z_twist, theta, phi, trans_vec)
	coord = rot_z_axis(coord, z_twist);
	coord = rot_y_axis(coord, theta);
	coord = rot_z_axis(coord, phi);
	coord = trans_coor(coord, trans_vec);
end